diff --git a/board/silverbox/memsetup.S b/board/silverbox/memsetup.S
index ae66e89..bdfa3d1 100644
--- a/board/silverbox/memsetup.S
+++ b/board/silverbox/memsetup.S
@@ -23,7 +23,6 @@
 
 #include <config.h>
 #include <version.h>
-#include <pnx8550_glb.h>
 #include <asm/regdef.h>
 #include <asm/mipsregs.h>
 
@@ -71,29 +70,29 @@ #define LOG2(x) ((((x)==0x00000001)/-1*0
 	.globl	lowlevel_init
 
 lowlevel_init:
-	/* Setup CMEM_0 to MMIO address space */
-	lui	t0, (PNX8550_MMIO >> 16)			/* Set offset */
-	ori	t0, t0, (LOG2(PNX8550_MMIO_SIZE >> 20)) << 1 |	/* Set size   */ \
-			PNX8550_CMEM0__ENABLE			/* Set Enable */
-	mtc0	$8, $22, 4
+	/* Setup CMEM0 to MMIO address space */
+	lui	t0, (MMIO_BASE >> 16)				/* Set offset */
+	ori	t0, t0, (LOG2(MMIO_SIZE >> 20)) << 1 |		/* Set size   */ \
+			CP0_CMEMx__ENABLE			/* Set Enable */
+	mtc0	t0, CP0_CMEM0, 4
 
-	/* Setup CMEM_1 to XIO space */
-	lui	t0, (PNX8550_XIO >> 16)				/* Set offset */
-	ori	t0, t0, (LOG2(PNX8550_XIO_SIZE >> 20)) << 1 |	/* Set size   */ \
-			PNX8550_CMEM1__ENABLE			/* Set Enable */
-	mtc0	$8, $22, 5
+	/* Setup CMEM1 to XIO space */
+	lui	t0, (XIO_BASE >> 16)				/* Set offset */
+	ori	t0, t0, (LOG2(XIO_SIZE >> 20)) << 1 |		/* Set size   */ \
+			CP0_CMEMx__ENABLE			/* Set Enable */
+	mtc0	t0, CP0_CMEM1, 5
 
-	/* Setup CMEM_2 to PCI memory space */
-	lui	t0, (PNX8550_PCIMEM >> 16)			/* Set offset */
-	ori	t0, t0, (LOG2(PNX8550_PCIMEM_SIZE >> 20)) << 1 |/* Set size   */ \
-			PNX8550_CMEM2__ENABLE			/* Set Enable */
-	mtc0	$8, $22, 6
+	/* Setup CMEM2 to PCI memory space */
+	lui	t0, (PCIMEM_BASE >> 16)				/* Set offset */
+	ori	t0, t0, (LOG2(PCIMEM_SIZE >> 20)) << 1 |	/* Set size   */ \
+			CP0_CMEMx__ENABLE			/* Set Enable */
+	mtc0	t0, CP0_CMEM2, 6
 
-	/* Setup CMEM_3, to PCI I/O space */
-	lui	t0, (PNX8550_PCIIO >> 16)			/* Set offset */
-	ori	t0, t0, (LOG2(PNX8550_PCIIO_SIZE >> 20)) << 1 |	/* Set size   */ \
-			PNX8550_CMEM3__ENABLE			/* Set Enable */
-	mtc0	$8, $22, 7
+	/* Setup CMEM3, to PCI I/O space */
+	lui	t0, (PCIIO_BASE >> 16)				/* Set offset */
+	ori	t0, t0, (LOG2(PCIIO_SIZE >> 20)) << 1 |		/* Set size   */ \
+			CP0_CMEMx__ENABLE			/* Set Enable */
+	mtc0	t0, CP0_CMEM3, 7
 
 	nop	/* Make sure CMEM area's aren't accesed withing 3 instructions */
 
diff --git a/board/silverbox/silverbox.c b/board/silverbox/silverbox.c
index 961965b..5076462 100644
--- a/board/silverbox/silverbox.c
+++ b/board/silverbox/silverbox.c
@@ -23,11 +23,9 @@
 
 #include <common.h>
 #include <command.h>
-#include <pnx8550_glb.h>
 #include <asm/io.h>
 #include <asm/mipsregs.h>
 #include <asm/addrspace.h>
-
 #include <nxp_uart_ip0107.h>
 
 #if defined(CONFIG_PCI)
@@ -52,7 +50,7 @@ #endif /* CONFIG_PCI || CONFIG_XIO */
 
 long int initdram(int board_type)
 {
-	return 64*1024*1024;
+	return SDRAM_SIZE;
 }
 
 /* In cpu/mips/cpu.c */
@@ -60,11 +58,11 @@ void write_one_tlb( int index, u32 pagem
 
 #if defined(CONFIG_PCI)
 static struct pci_controller hose;
-extern void init_pnx8550_pci (struct pci_controller *);
+extern void init_nxp_ipa051_pci (struct pci_controller *);
 
 void pci_init_board (void)
 {
-	init_pnx8550_pci(&hose);
+	init_nxp_ipa051_pci(&hose);
 }
 #endif
 
@@ -76,19 +74,19 @@ #ifdef CONFIG_PCI
 
 	/* Calc the PCI mem size code */
 	if (mem_size >= 128)
-		pci_mem_code = SIZE_128M;
+		pci_mem_code = IPA051_PCI_SETUP__BASExx_SIZ_128M;
 	else if (mem_size >= 64)
-		pci_mem_code = SIZE_64M;
+		pci_mem_code = IPA051_PCI_SETUP__BASExx_SIZ_64M;
 	else if (mem_size >= 32)
-		pci_mem_code = SIZE_32M;
+		pci_mem_code = IPA051_PCI_SETUP__BASExx_SIZ_32M;
 	else
-		pci_mem_code = SIZE_16M;
+		pci_mem_code = IPA051_PCI_SETUP__BASExx_SIZ_16M;
 
 	/* Set PCI_XIO registers */
-	writel(PNX8550_PCIMEM, IPA051_PCI_BASE1_LO);
-	writel(PNX8550_PCIMEM + PNX8550_PCIMEM_SIZE + 1, IPA051_PCI_BASE1_HI);
-	writel(PNX8550_PCIIO, IPA051_PCI_BASE2_LO);
-	writel(PNX8550_PCIIO + PNX8550_PCIIO_SIZE + 1, IPA051_PCI_BASE2_HI);
+	writel(PCIMEM_BASE, IPA051_PCI_BASE1_LO);
+	writel(PCIMEM_BASE + PCIMEM_SIZE + 1, IPA051_PCI_BASE1_HI);
+	writel(PCIIO_BASE, IPA051_PCI_BASE2_LO);
+	writel(PCIIO_BASE + PCIIO_SIZE + 1, IPA051_PCI_BASE2_HI);
 
 	/* Send memory transaction via PCI_BASE2 */
 	writel(0x00000000, IPA051_PCI_IO);
@@ -97,32 +95,35 @@ #ifdef CONFIG_PCI
 	writel(0xca, IPA051_UNLOCK_REGISTER);
 
 	/*
-	 * BAR0 of PNX8550 (pci base 10) must be zero in order for ide
+	 * BAR0 of IP A051 (pci base 10) must be zero in order for ide
 	 * to work, and in order for bus_to_baddr to work without any
 	 * hacks.
 	 */
 	writel(0x00000000, IPA051_BASE10);
 
 	/*
-	 *These two bars are set by default or the boot code.
+	 * These two bars are set by default or the boot code.
 	 * However, it's safer to set them here so we're not boot
 	 * code dependent.
 	 */
-	writel(PNX8550_MMIO, IPA051_BASE14);	/* PNX MMIO */
-	writel(PNX8550_XIO, IPA051_BASE18);	/* XIO      */
-
-	writel(PCI_EN_TA |
-		PCI_EN_PCI2MMI |
-		PCI_EN_XIO |
-		PCI_SETUP_BASE18_SIZE(SIZE_128M) |
-		PCI_SETUP_BASE18_EN |
-		PCI_SETUP_BASE14_EN |
-		PCI_SETUP_BASE10_PREF |
-		PCI_SETUP_BASE10_SIZE(pci_mem_code) |
-		PCI_SETUP_CFGMANAGE_EN |
-		PCI_SETUP_PCIARB_EN,			/* Enable PCI arbiter */
-		IPA051_PCI_SETUP);				/* PCI_SETUP */
-	writel(0x00000000, IPA051_PCI_CONTROL);	/* PCI_CONTROL */
+	writel(MMIO_BASE, IPA051_BASE14);		/* PNX MMIO */
+	writel(XIO_BASE, IPA051_BASE18);		/* XIO      */
+
+	writel( IPA051_PCI_SETUP__EN_TA |
+		IPA051_PCI_SETUP__EN_PCI2MMI |
+		IPA051_PCI_SETUP__EN_XIO |
+		IPA051_PCI_SETUP__BASE18_SIZ(IPA051_PCI_SETUP__BASExx_SIZ_128M) |
+		IPA051_PCI_SETUP__EN_BASE18 |
+		IPA051_PCI_SETUP__EN_BASE14 |
+		IPA051_PCI_SETUP__BASE10_PREFETCHABLE |
+		IPA051_PCI_SETUP__BASE10_SIZ(pci_mem_code) |
+		IPA051_PCI_SETUP__EN_CONFIG_MANAG |
+		IPA051_PCI_SETUP__EN_PCI_ARB,		/* Enable PCI arbiter */
+		IPA051_PCI_SETUP );			/* PCI_SETUP */
+
+	writel(0x00000000, IPA051_PCI_CONTROL);		/* PCI_CONTROL */
+#else
+	initdram(0);
 #endif /* CONFIG_PCI */
 
 	return 0;
diff --git a/cpu/mips/cpu.c b/cpu/mips/cpu.c
index f7d26c2..cfb1e3e 100644
--- a/cpu/mips/cpu.c
+++ b/cpu/mips/cpu.c
@@ -27,7 +27,6 @@ #include <asm/inca-ip.h>
 #include <asm/mipsregs.h>
 #ifdef CONFIG_SILVERBOX
 #  include <asm/io.h>
-#  include <pnx8550_glb.h>
 #  include <nxp_reset_ip0123.h>
 #endif /* CONFIG_SILVERBOX */
 
@@ -39,7 +38,7 @@ #elif defined(CONFIG_PURPLE) || defined(
 	void (*f)(void) = (void *) 0xbfc00000;
 	f();
 #elif defined(CONFIG_SILVERBOX)
-	writel(IP0123_RST_CTL__DO_SW_RST, IP0123_RST_CTL);
+	writel(IP0123_RST_CTL__DO_SW_RST, IP0123 + IP0123_RST_CTL);
 #endif
 	fprintf(stderr, "*** reset failed ***\n");
 	return 0;
diff --git a/drivers/Makefile b/drivers/Makefile
index c0906d2..2950565 100644
--- a/drivers/Makefile
+++ b/drivers/Makefile
@@ -41,7 +41,7 @@ COBJS	= 3c589.o \
 	  mpc8xx_pcmcia.o \
 	  natsemi.o ne2000.o netarm_eth.o netconsole.o ns16550.o \
 	  ns7520_eth.o ns8382x.o ns87308.o \
-	  nxp_i2c.o nxp_i2c_ip0105.o nxp_i2c_ip3203.o nxp_uart_ip0107.o \
+	  nxp_i2c.o nxp_i2c_ip0105.o nxp_i2c_ip3203.o nxp_uart_ip0107.o nxp_pcixio_ipa051.o \
 	  omap1510_i2c.o omap24xx_i2c.o \
 	  pc_keyb.o pci.o pci_auto.o pci_indirect.o pcnet.o \
 	  plb2800_eth.o ps2mult.o ps2ser.o pxa_pcmcia.o \
diff --git a/drivers/nxp_i2c.c b/drivers/nxp_i2c.c
index eedcf80..602dd84 100755
--- a/drivers/nxp_i2c.c
+++ b/drivers/nxp_i2c.c
@@ -28,7 +28,6 @@ #include <common.h>
 #ifdef CONFIG_NXP_I2C
 
 #include <asm/io.h>
-#include <pnx8550_glb.h>
 #include <i2c.h>
 
 #ifdef CONFIG_NXP_I2C_IP0105
@@ -86,9 +85,9 @@ void i2c_init (int speed, int slaveaddr)
 	unsigned long	addr ;
 	int		new_bus = 0;
 
-	addr = TO_UNCACHED(PNX8550_MMIO) ;
+	addr = TO_UNCACHED(MMIO_BASE) ;
 	while ( (new_bus < MAX_I2C_BUSSES) &&
-		(addr < (TO_UNCACHED(PNX8550_MMIO) + PNX8550_MMIO_SIZE)) ) {
+		(addr < (TO_UNCACHED(MMIO_BASE) + MMIO_SIZE)) ) {
 		unsigned long mod_id   =  (readl(addr + 0x0FFC) & 0xFFFF0000) >> 16 ;
 		unsigned long mod_size = ((readl(addr + 0x0FFC) & 0x000000FF) + 1) * 0x1000 ;
 
diff --git a/drivers/nxp_i2c_ip0105.c b/drivers/nxp_i2c_ip0105.c
index d3eebbe..7b7c448 100755
--- a/drivers/nxp_i2c_ip0105.c
+++ b/drivers/nxp_i2c_ip0105.c
@@ -28,7 +28,6 @@ #include <common.h>
 #ifdef CONFIG_NXP_I2C_IP0105
 
 #include <asm/io.h>
-#include <pnx8550_glb.h>
 #include "nxp_i2c_ip0105.h"
 
 /*-----------------------------------------------------------------------
diff --git a/drivers/nxp_i2c_ip3203.c b/drivers/nxp_i2c_ip3203.c
index a27c100..75f1e1f 100755
--- a/drivers/nxp_i2c_ip3203.c
+++ b/drivers/nxp_i2c_ip3203.c
@@ -28,7 +28,6 @@ #include <common.h>
 #ifdef CONFIG_NXP_I2C_IP3203
 
 #include <asm/io.h>
-#include <pnx8550_glb.h>
 #include "nxp_i2c_ip3203.h"
 
 /*-----------------------------------------------------------------------
diff --git a/drivers/nxp_pcixio_ipa051.c b/drivers/nxp_pcixio_ipa051.c
new file mode 100644
index 0000000..e73a7ec
--- /dev/null
+++ b/drivers/nxp_pcixio_ipa051.c
@@ -0,0 +1,330 @@
+/*
+ * (C) Copyright 2006
+ * NXP Semiconductors,
+ * Robert Delien robert.delien@nxp.com, Hans Zuidam hans.zuidam@nxp.com
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ *
+ */
+
+#include <common.h>
+#include <pci.h>
+#include <nxp_pcixio_ipa051.h>
+#include <asm/io.h>
+#include <asm/addrspace.h>
+
+
+#if defined(CONFIG_PCI) && defined(CONFIG_NXP_PCIXIO_IPA051)
+static inline void nxp_ipa051_pci_clear_status( void )
+{
+	unsigned long pci_stat;
+
+	pci_stat = inl(IPA051 + IPA051_GPPM_INT_STATUS);
+	outl(pci_stat, IPA051 + IPA051_GPPM_INT_CLR);
+}
+
+static inline unsigned int nxp_ipa051_pci_calc_cfg_addr( pci_dev_t	dev,
+							 int		where )
+{
+	unsigned int	addr;
+	u32		bus;
+	u32		device;
+
+	bus    = ((dev & 0x00FF0000) >> 16);
+	device = ((dev & 0x0000F800) >> 11);
+
+	addr  = ((bus > 0) ? ((bus << PCI_CFG_BUS_SHIFT) | 1) : 0);
+	addr |= (((dev >> 8) & 0xFF) << PCI_CFG_FUNC_SHIFT) | (where & 0xFC);
+
+	return addr;
+}
+
+static int nxp_ipa051_pci_io ( unsigned int	ioaddr,
+			       unsigned int	pci_mode,
+			       unsigned int	pci_cmd,
+			       unsigned int	*val )
+{
+	unsigned long retries = 0;
+
+	/* Clear pending interrupt status */
+	if (inl(IPA051 + IPA051_GPPM_INT_STATUS)) {
+		nxp_ipa051_pci_clear_status();
+		while (!(inl(IPA051 + IPA051_GPPM_INT_STATUS) == 0)) ;
+	}
+
+	outl(ioaddr, IPA051 + IPA051_GPPM_ADDR);
+
+	if ((pci_cmd == IPA051_GPPM_CTRL__GPPM_CMD_IO_WR) ||
+	    (pci_cmd == IPA051_GPPM_CTRL__GPPM_CMD_CFG_WR))
+		outl(*val, IPA051 + IPA051_GPPM_WDAT);
+
+	outl(IPA051_GPPM_CTRL__INIT_PCI_CYCLE | pci_cmd | (pci_mode & PCI_BYTE_ENABLE_MASK),
+	     IPA051 + IPA051_GPPM_CTRL);
+
+	while (1) {
+		if (inl(IPA051 + IPA051_GPPM_INT_STATUS) & IPA051_GPPM_INT__GPPM_DONE) {
+			if ((pci_cmd == IPA051_GPPM_CTRL__GPPM_CMD_IO_RD) ||
+			    (pci_cmd == IPA051_GPPM_CTRL__GPPM_CMD_CFG_RD))
+				*val = inl(IPA051 + IPA051_GPPM_RDAT);
+			nxp_ipa051_pci_clear_status();
+			return 0;
+		} else if (inl(IPA051 + IPA051_GPPM_INT_STATUS) & IPA051_GPPM_INT__GPPM_R_MABORT) {
+			break;
+		}
+
+		if (retries > (PCI_IO_TIMEOUT_US/PCI_IO_RETRYTIME_US)) {
+			printf("%s : Arbiter Locked.\n", __FUNCTION__);
+			return -1;
+		}
+		retries ++ ;
+		udelay(PCI_IO_RETRYTIME_US);
+	}
+
+	nxp_ipa051_pci_clear_status();
+	if ((pci_cmd == IPA051_GPPM_CTRL__GPPM_CMD_IO_RD) ||
+	    (pci_cmd == IPA051_GPPM_CTRL__GPPM_CMD_IO_WR)) {
+		printf("%s timeout (GPPM_CTRL=%X) ioaddr %X pci_cmd %X\n",
+		       __FUNCTION__, inl(IPA051 + IPA051_GPPM_CTRL), ioaddr,
+		       pci_cmd);
+	}
+
+	if ((pci_cmd == IPA051_GPPM_CTRL__GPPM_CMD_IO_RD) ||
+	    (pci_cmd == IPA051_GPPM_CTRL__GPPM_CMD_CFG_RD))
+		*val = 0xFFFFFFFF;
+	return 0;
+}
+
+/*
+ * We can't address 8 and 16 bit words directly.  Instead we have to
+ * read/write a 32bit word and mask/modify the data we actually want.
+ */
+static int nxp_ipa051_pcibios_read_config_byte( struct pci_controller	*hose,
+						pci_dev_t		dev,
+						int			where,
+						u8			*val )
+{
+	unsigned int	data = 0;
+	int		err;
+
+	if (dev == 0)
+		return -1;
+
+	err = nxp_ipa051_pci_io( nxp_ipa051_pci_calc_cfg_addr(dev, where),
+				 ~(1 << (where & 3)),
+				 IPA051_GPPM_CTRL__GPPM_CMD_CFG_RD,
+				 &data );
+
+	switch (where & 0x03) {
+	case 0:
+		*val = (unsigned char)(data & 0x000000FF);
+		break;
+	case 1:
+		*val = (unsigned char)((data & 0x0000FF00) >> 8);
+		break;
+	case 2:
+		*val = (unsigned char)((data & 0x00FF0000) >> 16);
+		break;
+	case 3:
+		*val = (unsigned char)((data & 0xFF000000) >> 24);
+		break;
+	}
+
+	return err;
+}
+
+static int nxp_ipa051_pcibios_read_config_word( struct pci_controller	*hose,
+						pci_dev_t		dev,
+						int			where,
+						u16			*val )
+{
+	unsigned int	data = 0;
+	int		err;
+
+	if (dev == 0)
+		return -1;
+
+	if (where & 0x01)
+		return -1;
+
+	err = nxp_ipa051_pci_io( nxp_ipa051_pci_calc_cfg_addr(dev, where),
+				 ~(3 << (where & 3)),
+				 IPA051_GPPM_CTRL__GPPM_CMD_CFG_RD,
+				 &data );
+
+	switch (where & 0x02) {
+	case 0:
+		*val = (unsigned short)(data & 0x0000FFFF);
+		break;
+	case 2:
+		*val = (unsigned short)((data & 0xFFFF0000) >> 16);
+		break;
+	}
+
+	return err;
+}
+
+static int nxp_ipa051_pcibios_read_config_dword( struct pci_controller	*hose,
+						 pci_dev_t		dev,
+						 int			where,
+						 u32			*val )
+{
+	int err;
+
+	if (dev == 0)
+		return -1;
+
+	if (where & 0x03)
+		return -1;
+
+	err = nxp_ipa051_pci_io( nxp_ipa051_pci_calc_cfg_addr(dev, where),
+				 0,
+				 IPA051_GPPM_CTRL__GPPM_CMD_CFG_RD,
+				 val );
+
+	return err;
+}
+
+static int nxp_ipa051_pcibios_write_config_byte( struct pci_controller	*hose,
+						 pci_dev_t		dev,
+						 int			where,
+						 u8			val )
+{
+	unsigned int	data = (unsigned int)val;
+	int		err;
+
+	if (dev == 0)
+		return -1;
+
+	switch (where & 0x03) {
+	case 1:
+		data = (data << 8);
+		break;
+	case 2:
+		data = (data << 16);
+		break;
+	case 3:
+		data = (data << 24);
+		break;
+	default:
+		break;
+	}
+
+	err = nxp_ipa051_pci_io( nxp_ipa051_pci_calc_cfg_addr(dev, where),
+				 ~(1 << (where & 3)),
+				 IPA051_GPPM_CTRL__GPPM_CMD_CFG_WR,
+				 &data );
+
+	return err;
+}
+
+static int nxp_ipa051_pcibios_write_config_word( struct pci_controller	*hose,
+						 pci_dev_t		dev,
+						 int			where,
+						 u16			val )
+{
+	unsigned int	data = (unsigned int)val;
+	int		err;
+
+	if (dev == 0)
+		return -1;
+
+	if (where & 0x01)
+		return -1;
+
+	switch (where & 0x02) {
+	case 2:
+		data = (data << 16);
+		break;
+	default:
+		break;
+	}
+
+	err = nxp_ipa051_pci_io( nxp_ipa051_pci_calc_cfg_addr(dev, where),
+				 ~(3 << (where & 3)),
+				 IPA051_GPPM_CTRL__GPPM_CMD_CFG_WR,
+				 &data );
+
+	return err;
+}
+
+static int nxp_ipa051_pcibios_write_config_dword( struct pci_controller	*hose,
+						  pci_dev_t		dev,
+						  int			where,
+						  u32			val )
+{
+	int err;
+
+	if (dev == 0)
+		return -1;
+
+	if (where & 0x03)
+		return -1;
+
+	err = nxp_ipa051_pci_io( nxp_ipa051_pci_calc_cfg_addr(dev, where),
+				 0,
+				 IPA051_GPPM_CTRL__GPPM_CMD_CFG_WR, &val );
+
+	return err;
+}
+
+
+/*
+ *	Initialize Module
+ */
+void init_nxp_ipa051_pci( struct pci_controller	*hose )
+{
+	hose->first_busno = 0x00;
+	hose->last_busno  = 0xFF;
+
+	/* PCI memory space #1 */
+	pci_set_region( hose->regions + 0,
+			PCIMEM_BASE,
+			TO_UNCACHED(PCIMEM_BASE),
+			PCIMEM_SIZE,
+			PCI_REGION_MEM );
+
+	/* PCI I/O space #2 */
+	pci_set_region( hose->regions + 1,
+			PCIIO_BASE,
+			TO_UNCACHED(PCIIO_BASE),
+			PCIIO_SIZE,
+			PCI_REGION_IO );
+
+	/* System memory space */
+	pci_set_region( hose->regions + 2,
+			SDRAM_BASE,
+			TO_CACHED(SDRAM_BASE),
+			SDRAM_SIZE,
+			PCI_REGION_MEM | PCI_REGION_MEMORY );
+
+	hose->region_count = 3;
+
+	hose->read_byte   = nxp_ipa051_pcibios_read_config_byte;
+	hose->read_word   = nxp_ipa051_pcibios_read_config_word;
+	hose->read_dword  = nxp_ipa051_pcibios_read_config_dword;
+	hose->write_byte  = nxp_ipa051_pcibios_write_config_byte;
+	hose->write_word  = nxp_ipa051_pcibios_write_config_word;
+	hose->write_dword = nxp_ipa051_pcibios_write_config_dword;
+
+	pci_register_hose(hose);
+
+	hose->last_busno = pci_hose_scan(hose);
+}
+
+#endif /* CONFIG_PCI && CONFIG_NXP_PCIXIO_IPA051 */
diff --git a/drivers/nxp_uart_ip0107.c b/drivers/nxp_uart_ip0107.c
index d16f956..cdc6e92 100644
--- a/drivers/nxp_uart_ip0107.c
+++ b/drivers/nxp_uart_ip0107.c
@@ -1,5 +1,5 @@
 /*
- * PNX8550 UART support
+ * NXP Semiconductors IP0107 UART support
  *
  * Copyright (c) 2004	Pete Popov, Embedded Alley Solutions, Inc
  * ppopov@embeddedalley.com
@@ -31,7 +31,6 @@ #include <config.h>
 #ifdef CFG_IP0107_UART
 
 #include <common.h>
-#include <pnx8550_glb.h>
 #include <asm/io.h>
 #include <nxp_uart_ip0107.h>
 
diff --git a/include/asm-mips/io.h b/include/asm-mips/io.h
index 857fb03..17658fe 100644
--- a/include/asm-mips/io.h
+++ b/include/asm-mips/io.h
@@ -447,4 +447,18 @@ #define dma_cache_wback_inv(start,size)	
 #define dma_cache_wback(start,size)	_dma_cache_wback(start,size)
 #define dma_cache_inv(start,size)	_dma_cache_inv(start,size)
 
+/*
+ * XXX: MIPS doesn't provide in_le32 etc functions. The externs
+ *      supplied here are just satisfying pci_indirect.c.
+ *	Some rework of pci_indirect.c may be required for indirect
+ *	PCI bridge support on both big and little endian MIPS targets.
+ */
+extern unsigned char	in_8     (volatile  u8 *addr);
+extern unsigned short	in_le16  (volatile u16 *addr);
+extern unsigned		in_le32  (volatile u32 *addr);
+extern void		out_8    (volatile  u8 *addr, char val);
+extern void		out_le16 (volatile u16 *addr, unsigned short val);
+extern void		out_le32 (volatile u32 *addr, unsigned int val);
+
+
 #endif /* _ASM_IO_H */
diff --git a/include/asm-mips/mipsregs.h b/include/asm-mips/mipsregs.h
index 394172e..13feed9 100644
--- a/include/asm-mips/mipsregs.h
+++ b/include/asm-mips/mipsregs.h
@@ -13,10 +13,6 @@
 #ifndef _ASM_MIPSREGS_H
 #define _ASM_MIPSREGS_H
 
-#if 0
-#include <linux/linkage.h>
-#endif
-
 /*
  * The following macros are especially useful for __asm__
  * inline assembler.
@@ -62,6 +58,16 @@ #define CP0_TAGLO $28
 #define CP0_TAGHI $29
 #define CP0_ERROREPC $30
 
+/* PR4450 specific */
+#ifdef CONFIG_MIPS_CPU_PR4450
+#define CP0_CMEM0		$22
+#define CP0_CMEM1		$22
+#define CP0_CMEM2		$22
+#define CP0_CMEM3		$22
+
+#define CP0_CMEMx__ENABLE	0x00000001
+#endif /* CONFIG_MIPS_CPU_PR4450 */
+
 /*
  * R4640/R4650 cp0 register names.  These registers are listed
  * here only for completeness; without MMU these CPUs are not useable
diff --git a/include/configs/silverbox.h b/include/configs/silverbox.h
index cf0e755..48ed0a3 100755
--- a/include/configs/silverbox.h
+++ b/include/configs/silverbox.h
@@ -34,12 +34,12 @@ #define __CONFIG_H
 
 #define CONFIG_SILVERBOX
 
+#include <pnx8550_glb.h>
+
 /* PNX8550 has a (modified) MIPS32 core */
 #define CONFIG_MIPS32					/* MIPS32 CPU core */
 #define CONFIG_MIPS_CPU_PR4450				/* Philips PR4450 implementation */
 
-#define CONFIG_LOADADDR		0x82000000		/* SDRAM address to load files to */
-
 #define CONFIG_BOOTDELAY	5	/* autoboot after 5 seconds	*/
 
 #define CONFIG_BAUDRATE		38400
@@ -59,13 +59,14 @@ #define CONFIG_EXTRA_ENV_SETTINGS					\
 
 #define CONFIG_BOOTCOMMAND	""
 
-#define CONFIG_COMMANDS		(CFG_CMD_BDI		|\
-				 CFG_CMD_LOADS		|\
-				 CFG_CMD_LOADB		|\
-				 CFG_CMD_MEMORY		|\
-				 CFG_CMD_ENV		|\
+#define CONFIG_COMMANDS	      (	(CONFIG_CMD_DFL		|\
+				 CFG_CMD_DHCP		|\
+				 CFG_CMD_PCI		|\
+				 CFG_CMD_ELF		|\
 				 CFG_CMD_I2C		|\
-				 CFG_CMD_EEPROM)
+				 CFG_CMD_EEPROM		|\
+				 CFG_CMD_PING)		&\
+ 				~(CFG_CMD_ENV | CFG_CMD_FLASH | CFG_CMD_IMLS ) )
 #include <cmd_confdefs.h>
 
 /*
@@ -122,6 +123,24 @@ #define CFG_ICACHE_SIZE		16384
 #define CFG_CACHELINE_SIZE	32
 
 /*-----------------------------------------------------------------------
+ * PCI stuff
+ */
+#define CONFIG_PCI
+#define CONFIG_PCI_PNP
+#define CONFIG_NXP_PCIXIO_IPA051
+
+/*-----------------------------------------------------------------------
+ * Network stuff
+ */
+#define CONFIG_RTL8139
+#define CONFIG_NET_MULTI
+#define CONFIG_SERVERIP		192.168.1.10		/* IP address of tftp server */
+#define CONFIG_IPADDR		192.168.1.26		/* Our IP address */
+#define CONFIG_NETMASK		255.255.255.0		/* Our net mask */
+#define CONFIG_BOOTFILE		/vmlinux-sb		/* File to boot */
+#define CONFIG_LOADADDR		0x82000000		/* SDRAM address to load files to */
+
+/*-----------------------------------------------------------------------
  * I2C stuff
  */
 #define CONFIG_NXP_I2C
diff --git a/include/nxp_global2_ip0128.h b/include/nxp_global2_ip0128.h
index 8d8eded..1aa77e7 100644
--- a/include/nxp_global2_ip0128.h
+++ b/include/nxp_global2_ip0128.h
@@ -29,7 +29,7 @@ #define NXP_GLOBAL2_IP0128_H
 /*
  * Register address definitions
  */
-#define IP0128_ENABLE_INTA_O			((IP0128) + 0x00000050)
+#define IP0128_ENABLE_INTA_O			0x00000050
 
 
 /*
diff --git a/include/nxp_gpio_ip010f.h b/include/nxp_gpio_ip010f.h
index 8ac2628..7b0cddc 100644
--- a/include/nxp_gpio_ip010f.h
+++ b/include/nxp_gpio_ip010f.h
@@ -29,8 +29,8 @@ #define NXP_GPIO_IP010F_H
 /*
  * Register address definitions
  */
-#define IP010F_DIRQ0			((IP010F) + 0x00000500)
-#define IP010F_MODE_CONTROL1		((IP010F) + 0x00000004)
+#define IP010F_DIRQ0			0x00000500
+#define IP010F_MODE_CONTROL1		0x00000004
 
 
 /*
diff --git a/include/nxp_pcixio_ipa051.h b/include/nxp_pcixio_ipa051.h
index 6f62bf3..7bcce72 100644
--- a/include/nxp_pcixio_ipa051.h
+++ b/include/nxp_pcixio_ipa051.h
@@ -26,104 +26,92 @@
 #ifndef NXP_PCIXIO_IPA051_H
 #define NXP_PCIXIO_IPA051_H
 
-#ifdef CONFIG_PCI
-
-#define PCI_ACCESS_READ			0
-#define PCI_ACCESS_WRITE		1
-
-#define PCI_CMD_IOR                     0x20
-#define PCI_CMD_IOW                     0x30
-#define PCI_CMD_CONFIG_READ             0xA0
-#define PCI_CMD_CONFIG_WRITE            0xB0
-
-#define PCI_IO_TIMEOUT                  1000
-#define PCI_IO_RETRY			5
-/* Timeout for IO and CFG accesses.
-   This is in 1/1024 th of a jiffie(=10ms)
-   i.e. approx 10us */
-#define PCI_IO_JIFFIES_TIMEOUT          40
-#define PCI_IO_JIFFIES_SHIFT            10
+/*
+ * Timeout and retry time for IO and CFG accesses
+ * in microseconds
+ */
+#define PCI_IO_TIMEOUT_US			10
+#define PCI_IO_RETRYTIME_US			1
 
-#define PCI_BYTE_ENABLE_MASK		0x0000000F
-#define PCI_CFG_BUS_SHIFT               16
-#define PCI_CFG_FUNC_SHIFT              8
-#define PCI_CFG_REG_SHIFT               2
+#define PCI_BYTE_ENABLE_MASK			0x0000000F
+#define PCI_CFG_BUS_SHIFT			16
+#define PCI_CFG_FUNC_SHIFT			8
 
 /*
  * Register address definitions
  */
-#define IPA051_PCI_SETUP			((IPA051) + 0x00000010)
-#define IPA051_PCI_CONTROL			((IPA051) + 0x00000014)
-#define IPA051_PCI_BASE1_LO			((IPA051) + 0x00000018)
-#define IPA051_PCI_BASE1_HI			((IPA051) + 0x0000001C)
-#define IPA051_PCI_BASE2_LO			((IPA051) + 0x00000020)
-#define IPA051_PCI_BASE2_HI			((IPA051) + 0x00000024)
-#define IPA051_READ_LIFETIME			((IPA051) + 0x00000028)
-#define IPA051_GPPM_ADDR			((IPA051) + 0x0000002C)
-#define IPA051_GPPM_WDATA			((IPA051) + 0x00000030)
-#define IPA051_GPPM_RDATA			((IPA051) + 0x00000034)
-#define IPA051_GPPM_CTRL			((IPA051) + 0x00000038)
-#define IPA051_UNLOCK_REGISTER			((IPA051) + 0x0000003C)
-#define IPA051_DEVICE_VENDORID			((IPA051) + 0x00000040)
-#define IPA051_CONFIG_CMD_STAT			((IPA051) + 0x00000044)
-#define IPA051_CLASS_CODE_REV_ID		((IPA051) + 0x00000048)
-#define IPA051_LATENCY_TIMER			((IPA051) + 0x0000004c)
-#define IPA051_BASE10				((IPA051) + 0x00000050)
-#define IPA051_BASE14				((IPA051) + 0x00000054)
-#define IPA051_BASE18				((IPA051) + 0x00000058)
-/*	IPA051_RESERVED				((IPA051) + 0x0000005C ... 0x00000060 */
-#define IPA051_SUBSYSTEM_IDS			((IPA051) + 0x0000006c)
-/*	IPA051_RESERVED				((IPA051) + 0x00000070 */
-#define IPA051_CAP_PTR				((IPA051) + 0x00000074)
-/*	IPA051_RESERVED				((IPA051) + 0x00000078 */
-#define IPA051_CONFIG_MISC			((IPA051) + 0x0000007C)
-#define IPA051_PMC				((IPA051) + 0x00000080)
-#define IPA051_PWR_STATE			((IPA051) + 0x00000084)
-#define IPA051_PCI_IO				((IPA051) + 0x00000088)
-#define IPA051_SLV_TUNING			((IPA051) + 0x0000008C)
-#define IPA051_DMA_TUNING			((IPA051) + 0x00000090)
-/*	IPA051_RESERVED				((IPA051) + 0x00000094 ... 0x000007FC */
-#define IPA051_DMA_EADDR			((IPA051) + 0x00000800)
-#define IPA051_DMA_IADDR			((IPA051) + 0x00000804)
-#define IPA051_DMA_LENGTH			((IPA051) + 0x00000808)
-#define IPA051_DMA_CTRL				((IPA051) + 0x0000080C)
-#define IPA051_XIO_CTRL				((IPA051) + 0x00000810)
-#define IPA051_XIO_SEL0_PROF			((IPA051) + 0x00000814)
-#define IPA051_XIO_SEL1_PROF			((IPA051) + 0x00000818)
-#define IPA051_XIO_SEL2_PROF			((IPA051) + 0x0000081C)
-#define IPA051_GPXIO_ADDR			((IPA051) + 0x00000820)
-#define IPA051_GPXIO_WDATA			((IPA051) + 0x00000824)
-#define IPA051_GPXIO_RDATA			((IPA051) + 0x00000828)
-#define IPA051_GPXIO_CTRL			((IPA051) + 0x0000082C)
-#define IPA051_NAND_CTRLS			((IPA051) + 0x00000830)
-#define IPA051_XIO_SEL3_PROF			((IPA051) + 0x00000834)
-#define IPA051_XIO_SEL4_PROF			((IPA051) + 0x00000838)
-/*	IPA051_RESERVED				((IPA051) + 0x0000083C ... 0x00000FAC */
-#define IPA051_GPXIO_STATUS			((IPA051) + 0x00000FB0)
-#define IPA051_GPXIO_INT_MASK			((IPA051) + 0x00000FB4)
-#define IPA051_GPXIO_INT_CLR			((IPA051) + 0x00000FB8)
-#define IPA051_GPXIO_INT_SET			((IPA051) + 0x00000FBC)
-#define IPA051_GPPM_STATUS			((IPA051) + 0x00000FC0)
-#define IPA051_GPPM_INT_MASK			((IPA051) + 0x00000FC4)
-#define IPA051_GPPM_INT_CLR			((IPA051) + 0x00000FC8)
-#define IPA051_GPPM_INT_SET			((IPA051) + 0x00000FCC)
-#define IPA051_DMA_STATUS			((IPA051) + 0x00000FD0)
-#define IPA051_DMA_INT_MASK			((IPA051) + 0x00000FD4)
-#define IPA051_DMA_INT_CLR			((IPA051) + 0x00000FD8)
-#define IPA051_DMA_INT_SET			((IPA051) + 0x00000FDC)
-#define IPA051_PCI_STATUS			((IPA051) + 0x00000FE0)
-#define IPA051_PCI_INT_MASK			((IPA051) + 0x00000FE4)
-#define IPA051_PCI_INT_CLR			((IPA051) + 0x00000FE8)
-#define IPA051_PCI_INT_SET			((IPA051) + 0x00000FEC)
-/*	IPA051_RESERVED				((IPA051) + 0x00000FF0 ... 0x00000FF8 */
-#define IPA051_PCI_MODULE_ID			((IPA051) + 0x00000FFC)
+#define IPA051_PCI_SETUP			0x00000010
+#define IPA051_PCI_CONTROL			0x00000014
+#define IPA051_PCI_BASE1_LO			0x00000018
+#define IPA051_PCI_BASE1_HI			0x0000001C
+#define IPA051_PCI_BASE2_LO			0x00000020
+#define IPA051_PCI_BASE2_HI			0x00000024
+#define IPA051_READ_LIFETIME			0x00000028
+#define IPA051_GPPM_ADDR			0x0000002C
+#define IPA051_GPPM_WDAT			0x00000030
+#define IPA051_GPPM_RDAT			0x00000034
+#define IPA051_GPPM_CTRL			0x00000038
+#define IPA051_UNLOCK_REGISTER			0x0000003C
+#define IPA051_DEVICE_VENDORID			0x00000040
+#define IPA051_CONFIG_CMD_STAT			0x00000044
+#define IPA051_CLASS_CODE_REV_ID		0x00000048
+#define IPA051_LATENCY_TIMER			0x0000004C
+#define IPA051_BASE10				0x00000050
+#define IPA051_BASE14				0x00000054
+#define IPA051_BASE18				0x00000058
+/*	IPA051_RESERVED				0x0000005C ... 0x00000060 */
+#define IPA051_SUBSYSTEM_IDS			0x0000006C
+/*      IPA051_RESERVED				0x00000070 */
+#define IPA051_CAP_POINTER			0x00000074
+/*      IPA051_RESERVED				0x00000078 */
+#define IPA051_CONFIG_MISC			0x0000007C
+#define IPA051_PMC				0x00000080
+#define IPA051_PWR_STATE			0x00000084
+#define IPA051_PCI_IO				0x00000088
+#define IPA051_SLV_TUNING			0x0000008C
+#define IPA051_DMA_TUNING			0x00000090
+/*	IPA051_RESERVED				0x00000094 ... 0x000007FC */
+#define IPA051_DMA_EADDR			0x00000800
+#define IPA051_DMA_IADDR			0x00000804
+#define IPA051_DMA_LENGTH			0x00000808
+#define IPA051_DMA_CTRL				0x0000080C
+#define IPA051_XIO_CTRL				0x00000810
+#define IPA051_XIO_SEL0_PROF			0x00000814
+#define IPA051_XIO_SEL1_PROF			0x00000818
+#define IPA051_XIO_SEL2_PROF			0x0000081C
+#define IPA051_GPXIO_ADDR			0x00000820
+#define IPA051_GPXIO_WDATA			0x00000824
+#define IPA051_GPXIO_RDATA			0x00000828
+#define IPA051_GPXIO_CTRL			0x0000082C
+#define IPA051_NAND_CTRLS			0x00000830
+#define IPA051_XIO_SEL3_PROF			0x00000834
+#define IPA051_XIO_SEL4_PROF			0x00000838
+/*	IPA051_RESERVED				0x0000083C ... 0x00000FAC */
+#define IPA051_GPXIO_INT_STATUS			0x00000FB0
+#define IPA051_GPXIO_INT_MASK			0x00000FB4
+#define IPA051_GPXIO_INT_CLR			0x00000FB8
+#define IPA051_GPXIO_INT_SET			0x00000FBC
+#define IPA051_GPPM_INT_STATUS			0x00000FC0
+#define IPA051_GPPM_INT_MASK			0x00000FC4
+#define IPA051_GPPM_INT_CLR			0x00000FC8
+#define IPA051_GPPM_INT_SET			0x00000FCC
+#define IPA051_DMA_INT_STATUS			0x00000FD0
+#define IPA051_DMA_INT_MASK			0x00000FD4
+#define IPA051_DMA_INT_CLR			0x00000FD8
+#define IPA051_DMA_INT_SET			0x00000FDC
+#define IPA051_PCI_INT_STATUS			0x00000FE0
+#define IPA051_PCI_INT_MASK			0x00000FE4
+#define IPA051_PCI_INT_CLR			0x00000FE8
+#define IPA051_PCI_INT_SET			0x00000FEC
+/*	IPA051_RESERVED				0x00000FF0 ... 0x00000FF8 */
+#define IPA051_MODULE_ID			0x00000FFC
 
 
 /*
  * Register layout definitions
  */
 
-/* IPA051_GPXIO_CTRL */
+/* IPA051_GPXIO_CTRL register fields */
 #define IPA051_GPXIO_CTRL__GPXIO_CYC_PENDING	(1 << 9)
 #define IPA051_GPXIO_CTRL__GPXIO_DONE		(1 << 8)
 #define IPA051_GPXIO_CTRL__CLR_GPXIO_DONE	(1 << 7)
@@ -131,7 +119,7 @@ #define IPA051_GPXIO_CTRL__GPXIO_INIT		(
 #define IPA051_GPXIO_CTRL__GPXIO_RD		(1 << 4)
 #define IPA051_GPXIO_CTRL__GPXIO_BEN(X)		((X) & 0x0000000F)
 
-/* IPA051_NAND_CTRLS */
+/* IPA051_NAND_CTRLS register fields */
 #define IPA051_NAND_CTRLS__CTRLS_64MB		(1 << 21)
 #define IPA051_NAND_CTRLS__CTRLS_INC_DATA	(1 << 20)
 #define IPA051_NAND_CTRLS__CTRLS_CMD_PH(X)	(((X) & 0x00000003) << 18)
@@ -139,13 +127,13 @@ #define IPA051_NAND_CTRLS__CTRLS_ADR_PH(
 #define IPA051_NAND_CTRLS__COMMAND_B(X)		(((X) << 8) & 0x0000FF00)
 #define IPA051_NAND_CTRLS__COMMAND_A(X)		((X) & 0x000000FF)
 
-/* IPA051_GPXIO_STATUS */
+/* IPA051_GPXIO_STATUS register fields */
 #define IPA051_GPXIO_STATUS__GPXIO_XIO_ACK_DONE	(1 << 14)
 #define IPA051_GPXIO_STATUS__GPXIO_DONE		(1 << 13)
 #define IPA051_GPXIO_STATUS__GPXIO_ERR		(1 << 9)
 #define IPA051_GPXIO_STATUS__GPXIO_R_MABORT	(1 << 2)
 
-/* IPA051_DMA_CTRL */
+/* IPA051_DMA_CTRL register fields */
 #define IPA051_DMA_CTRL__SINGLE_DATA_PHASE	(1 << 10)
 #define IPA051_DMA_CTRL__SND2XIO		(1 << 9)
 #define IPA051_DMA_CTRL__FIX_ADDR		(1 << 8)
@@ -161,10 +149,8 @@ #define IPA051_DMA_CTRL__MAX_BURST_SIZE_
 #define IPA051_DMA_CTRL__INIT_DMA		(1 << 4)
 #define IPA051_DMA_CTRL__CMD_TYPE(x)		((X) & 0x0000000F)
 
-/*
- * IPA051_XIO_SEL0_PROF, IPA051_XIO_SEL1_PROF, IPA051_XIO_SEL2_PROF,
- * IPA051_XIO_SEL3_PROF, IPA051_XIO_SEL4_PROF
- */
+/* IPA051_XIO_SEL0_PROF, IPA051_XIO_SEL1_PROF, IPA051_XIO_SEL2_PROF,
+ * IPA051_XIO_SEL3_PROF, IPA051_XIO_SEL4_PROF register fields */
 #define IPA051_XIO_SELx_PROF__MISC_CTRL		(1 << 24)
 #define IPA051_XIO_SELx_PROF__EN_16BIT		(1 << 23)
 #define IPA051_XIO_SELx_PROF__USE_ACK		(1 << 22)
@@ -184,99 +170,51 @@ #define IPA051_XIO_SELx_PROF__SIZE_32MB	
 #define IPA051_XIO_SELx_PROF__SIZE_64MB		0x00000006
 #define IPA051_XIO_SELx_PROF__ENAB		(1 << 0)
 
-
-#define PCI_DIS_REQGNT				(1 << 30)
-#define PCI_DIS_REQGNTA				(1 << 29)
-#define PCI_DIS_REQGNTB				(1 << 28)
-#define PCI_D2_SUPPORT				(1 << 27)
-#define PCI_D1_SUPPORT				(1 << 26)
-#define PCI_EN_TA				(1 << 24)
-#define PCI_EN_PCI2MMI				(1 << 23)
-#define PCI_EN_XIO				(1 << 22)
-#define PCI_BASE18_PREF				(1 << 21)
-#define SIZE_16M				0x3
-#define SIZE_32M				0x4
-#define SIZE_64M				0x5
-#define SIZE_128M				0x6
-#define PCI_SETUP_BASE18_SIZE(X)		((X) << 18)
-#define PCI_SETUP_BASE18_EN			(1 << 17)
-#define PCI_SETUP_BASE14_PREF			(1 << 16)
-#define PCI_SETUP_BASE14_SIZE(X)		((X) << 12)
-#define PCI_SETUP_BASE14_EN			(1 << 11)
-#define PCI_SETUP_BASE10_PREF			(1 << 10)
-#define PCI_SETUP_BASE10_SIZE(X)		((X) << 7)
-#define PCI_SETUP_CFGMANAGE_EN			(1 << 1)
-#define PCI_SETUP_PCIARB_EN			(1 << 0)
-
-#define PCI_SWPB_DCS_PCI			(1 << 16)
-#define PCI_SWPB_PCI_PCI			(1 << 15)
-#define PCI_SWPB_PCI_DCS			(1 << 14)
-#define PCI_REG_WR_POST				(1 << 13)
-#define PCI_XIO_WR_POST				(1 << 12)
-#define PCI_PCI2_WR_POST			(1 << 13)
-#define PCI_PCI1_WR_POST			(1 << 12)
-#define PCI_SERR_SEEN				(1 << 11)
-#define PCI_B10_SPEC_RD				(1 << 6)
-#define PCI_B14_SPEC_RD				(1 << 5)
-#define PCI_B18_SPEC_RD				(1 << 4)
-#define PCI_B10_NOSUBWORD			(1 << 3)
-#define PCI_B14_NOSUBWORD			(1 << 2)
-#define PCI_B18_NOSUBWORD			(1 << 1)
-#define PCI_RETRY_TMREN				(1 << 0)
-
-#if 0
-#define PNX8550_XIO_INT_ACK			0x00004000
-#define PNX8550_XIO_INT_COMPL			0x00002000
-#define PNX8550_XIO_INT_NONSUP			0x00000200
-#define PNX8550_XIO_INT_ABORT			0x00000004
-
-#define PNX8550_DMA_INT_ACK			0x00004000
-#define PNX8550_DMA_INT_COMPL			0x00001000
-#define PNX8550_DMA_INT_NONSUP			0x00000200
-#define PNX8550_DMA_INT_ABORT			0x00000004
-#endif
-
-
-
-#define GPPM_DONE				(1 << 10)
-#define INIT_PCI_CYCLE				(1 << 9)
-#define GPPM_CMD(X)				(((X) & 0xF) << 4)
-#define GPPM_BYTEEN(X)				((X) & 0xF)
-#define UNLOCK_SSID(X)				(((X)& 0xFF) << 8)
-#define UNLOCK_SETUP(X)				(((X)& 0xFF) << 0)
-#define UNLOCK_MAGIC				0xCA
-#define DEVICE_ID(X)				(((X) >> 16)& 0xFFFF)
-#define VENDOR_ID(X)				(((X) & 0xFFFF))
-#define PCI_CFG_STATUS(X)			(((X) >> 16) & 0xFFFF)
-#define PCI_CFG_COMMAND(X)			((X) & 0xFFFF)
-#define PCI_CLASSCODE(X)			(((X) >> 8) & 0xFFFFFF)
-#define PCI_REVID(X)				((X) & 0xFF)
-#define PCI_PMC					0x040080
-#define GPPM_DONE				(1 << 10)
-#define GPPM_ERR				(1 << 9)
-#define GPPM_MPAR_ERR				(1 << 8)
-#define GPPM_PAR_ERR				(1 << 7)
-#define GPPM_R_MABORT				(1 << 2)
-#define GPPM_R_TABORT				(1 << 1)
-
-/*
- *  PCI configuration cycle AD bus definition
- */
-/* Type 0 */
-#define PCI_CFG_TYPE0_REG_SHF			0
-#define PCI_CFG_TYPE0_FUNC_SHF			8
-
-/* Type 1 */
-#define PCI_CFG_TYPE1_REG_SHF			0
-#define PCI_CFG_TYPE1_FUNC_SHF			8
-#define PCI_CFG_TYPE1_DEV_SHF			11
-#define PCI_CFG_TYPE1_BUS_SHF			16
-
-/*
- *  Ethernet device DP83816 definition
- */
-#define DP83816_IRQ_ETHER			66
-
-#endif /* CONFIG_PCI */
+/* IPA051_GPPM_CTRL register fields */
+#define IPA051_GPPM_CTRL__GPPM_DONE		(1<<10)
+#define IPA051_GPPM_CTRL__INIT_PCI_CYCLE	(1<<9)
+#define IPA051_GPPM_CTRL__GPPM_CMD_IO_RD	0x00000020
+#define IPA051_GPPM_CTRL__GPPM_CMD_IO_WR	0x00000030
+#define IPA051_GPPM_CTRL__GPPM_CMD_MEM_RD	0x00000060 /*?*/
+#define IPA051_GPPM_CTRL__GPPM_CMD_MEM_WR	0x00000070 /*?*/
+#define IPA051_GPPM_CTRL__GPPM_CMD_CFG_RD	0x000000A0
+#define IPA051_GPPM_CTRL__GPPM_CMD_CFG_WR	0x000000B0
+#define IPA051_GPPM_CTRL__GPPM_CMD(X)		(((X)&0x0000000F)<<4)
+#define IPA051_GPPM_CTRL__GPPM_BEN(X)		((X)&0x0000000F)
+
+/* IPA051_GPPM_INT register fields */
+#define IPA051_GPPM_INT__GPPM_DONE		(1<<10)
+#define IPA051_GPPM_INT__GPPM_ERR		(1<<9)
+#define IPA051_GPPM_INT__GPPM_MSTR_PARITY_ERR	(1<<5)
+#define IPA051_GPPM_INT__GPPM_ERR_PARITY	(1<<4)
+#define IPA051_GPPM_INT__GPPM_R_MABORT		(1<<2)
+#define IPA051_GPPM_INT__GPPM_R_TABORT		(1<<1)
+
+/* IPA051_PCI_SETUP register fields */
+#define IPA051_PCI_SETUP__DIS_REQGNT		(1<<30)
+#define IPA051_PCI_SETUP__DIS_REQGNT_A		(1<<29)
+#define IPA051_PCI_SETUP__DIS_REQGNT_B		(1<<28)
+#define IPA051_PCI_SETUP__D2_SUPPORT		(1<<27)
+#define IPA051_PCI_SETUP__D1_SUPPORT		(1<<26)
+#define IPA051_PCI_SETUP__EN_TA			(1<<24)
+#define IPA051_PCI_SETUP__EN_PCI2MMI		(1<<23)
+#define IPA051_PCI_SETUP__EN_XIO		(1<<22)
+#define IPA051_PCI_SETUP__BASE18_PREFETCHABLE	(1<<21)
+#define IPA051_PCI_SETUP__BASE18_SIZ(X)		(X<<18)
+#define IPA051_PCI_SETUP__EN_BASE18		(1<<17)
+#define IPA051_PCI_SETUP__BASE14_PREFETCHABLE	(1<<16)
+#define IPA051_PCI_SETUP__BASE14_SIZ(X)		(X<<12)
+#define IPA051_PCI_SETUP__EN_BASE14		(1<<11)
+#define IPA051_PCI_SETUP__BASE10_PREFETCHABLE	(1<<10)
+#define IPA051_PCI_SETUP__BASE10_SIZ(X)		(X<<7)
+#define IPA051_PCI_SETUP__EN_CONFIG_MANAG	(1<<1)
+#define IPA051_PCI_SETUP__EN_PCI_ARB		(1<<0)
+#define IPA051_PCI_SETUP__BASExx_SIZ_16M	0x00000003
+#define IPA051_PCI_SETUP__BASExx_SIZ_32M	0x00000004
+#define IPA051_PCI_SETUP__BASExx_SIZ_64M	0x00000005
+#define IPA051_PCI_SETUP__BASExx_SIZ_128M	0x00000006
+
+
+void init_nxp_ipa051_pci(struct pci_controller*) ;
 
 #endif /* NXP_PCIXIO_IPA051_H */
diff --git a/include/nxp_reset_ip0123.h b/include/nxp_reset_ip0123.h
index 29c10f1..becb7f7 100644
--- a/include/nxp_reset_ip0123.h
+++ b/include/nxp_reset_ip0123.h
@@ -29,11 +29,11 @@ #define NXP_RESET_IP0123_H
 /*
  * Register address definitions
  */
-#define IP0123_RST_CTL				((IP0123) + 0x00000000)
-#define IP0123_RST_CAUSE			((IP0123) + 0x00000004)
-#define IP0123_RST_EN_WATCHDOG_RST		((IP0123) + 0x00000008)
-#define IP0123_RESERVED				((IP0123) + 0x0000000C)
-#define IP0123_MODULE_ID			((IP0123) + 0x00000FFC)
+#define IP0123_RST_CTL				0x00000000
+#define IP0123_RST_CAUSE			0x00000004
+#define IP0123_RST_EN_WATCHDOG_RST		0x00000008
+#define IP0123_RESERVED				0x0000000C
+#define IP0123_MODULE_ID			0x00000FFC
 
 
 /*
diff --git a/include/pnx8550_glb.h b/include/pnx8550_glb.h
index 02dc4f4..44ae127 100644
--- a/include/pnx8550_glb.h
+++ b/include/pnx8550_glb.h
@@ -31,39 +31,32 @@ #define TO_UNCACHED(addr)	((unsigned lon
 #define TO_CACHED(addr)		((unsigned long)(addr) | 0x80000000UL)
 
 /* Physical Mappings */
-#define PNX8550_SDRAM		0x00000000
-#define PNX8550_SDRAM_SIZE	0x04000000      /* 64MiB */
-#define PNX8550_XIO		0x10000000
-#define PNX8550_XIO_SIZE	0x04000000	/* 64MiB (pwr of 2, 1 MiB minimum) */
-#define PNX8550_MMIO		0x1BE00000
-#define PNX8550_MMIO_SIZE	0x00200000	/*  2MiB (pwr of 2, 1 MiB minimum) */
-#define PNX8550_PCIMEM		0x1C000000
-#define PNX8550_PCIMEM_SIZE	0x02000000	/* 32MiB (pwr of 2, 1 MiB minimum) */
-#define PNX8550_PCIIO		0x1E000000
-#define PNX8550_PCIIO_SIZE	0x02000000	/* 32MiB (pwr of 2, 1 MiB minimum) */
-
-#define PNX8550_PORT_BASE	KSEG1
+#define SDRAM_BASE		0x00000000
+#define SDRAM_SIZE		0x04000000      /* 64MiB */
+#define XIO_BASE		0x10000000
+#define XIO_SIZE		0x04000000	/* 64MiB (pwr of 2, 1 MiB minimum) */
+#define MMIO_BASE		0x1BE00000
+#define MMIO_SIZE		0x00200000	/*  2MiB (pwr of 2, 1 MiB minimum) */
+#define PCIMEM_BASE		0x1C000000
+#define PCIMEM_SIZE		0x02000000	/* 32MiB (pwr of 2, 1 MiB minimum) */
+#define PCIIO_BASE		0x1E000000
+#define PCIIO_SIZE		0x02000000	/* 32MiB (pwr of 2, 1 MiB minimum) */
 
 /* MDCS/TDCS busses in MMIO */
-#define PNX8550_MDCS		(TO_UNCACHED(PNX8550_MMIO) + 0x00000000)
-#define PNX8550_MDCS_SIZE	0x00100000	/*  1MiB */
-#define PNX8550_TDCS		(TO_UNCACHED(PNX8550_MMIO) + 0x00100000)
-#define PNX8550_TDCS_SIZE	0x00100000	/*  1MiB */
+#define MDCS_BASE		(TO_UNCACHED(MMIO_BASE) + 0x00000000)
+#define MDCS_SIZE		0x00100000	/*  1MiB */
+#define TDCS_BASE		(TO_UNCACHED(MMIO_BASE) + 0x00100000)
+#define TDCS_SIZE		0x00100000	/*  1MiB */
 
 /* IP block register offsets */
-#define IPA051			((TO_UNCACHED(PNX8550_MMIO)) + 0x00040000)	/* PCIXIO */
-#define IP0123			((TO_UNCACHED(PNX8550_MMIO)) + 0x00060000)	/* Reset */
-#define IP0126			((TO_UNCACHED(PNX8550_MMIO)) + 0x00063000)	/* Global */
-#define IP0128			((TO_UNCACHED(PNX8550_MMIO)) + 0x0004D000)	/* Global 2 */
-#define IP2031			((TO_UNCACHED(PNX8550_MMIO)) + 0x00065000)	/* SDRAM */
-#define IP010F			((TO_UNCACHED(PNX8550_MMIO)) + 0x00104000)	/* GPIO */
-#define IP0107_1		((TO_UNCACHED(PNX8550_MMIO)) + 0x0004A000)	/* UART1 */
-#define IP0107_2		((TO_UNCACHED(PNX8550_MMIO)) + 0x0004B000)	/* UART2 */
-#define IP0107_3		((TO_UNCACHED(PNX8550_MMIO)) + 0x0004C000)	/* UART3 */
-
-#define PNX8550_CMEM0__ENABLE	0x00000001
-#define PNX8550_CMEM1__ENABLE	0x00000001
-#define PNX8550_CMEM2__ENABLE	0x00000001
-#define PNX8550_CMEM3__ENABLE	0x00000001
+#define IPA051			((TO_UNCACHED(MMIO_BASE)) + 0x00040000)	/* PCIXIO */
+#define IP0123			((TO_UNCACHED(MMIO_BASE)) + 0x00060000)	/* Reset */
+#define IP0126			((TO_UNCACHED(MMIO_BASE)) + 0x00063000)	/* Global */
+#define IP0128			((TO_UNCACHED(MMIO_BASE)) + 0x0004D000)	/* Global 2 */
+#define IP2031			((TO_UNCACHED(MMIO_BASE)) + 0x00065000)	/* SDRAM */
+#define IP010F			((TO_UNCACHED(MMIO_BASE)) + 0x00104000)	/* GPIO */
+#define IP0107_1		((TO_UNCACHED(MMIO_BASE)) + 0x0004A000)	/* UART1 */
+#define IP0107_2		((TO_UNCACHED(MMIO_BASE)) + 0x0004B000)	/* UART2 */
+#define IP0107_3		((TO_UNCACHED(MMIO_BASE)) + 0x0004C000)	/* UART3 */
 
 #endif /* PNX8550_GLB_H */
